import { Kernel as JupyterKernel, ServerConnection, KernelManager, SessionManager, KernelMessage, KernelSpecManager } from '@jupyterlab/services';
import { ISessionConnection } from '@jupyterlab/services/lib/session/session';
export type IKernelProps = {
    kernelManager: KernelManager;
    kernelName: string;
    serverSettings: ServerConnection.ISettings;
    kernelModel?: JupyterKernel.IModel;
};
export declare class Kernel {
    private _kernelSpecManager;
    private _kernelManager;
    private _sessionManager;
    private _kernelName;
    private _kernelConnection;
    private _session;
    private _path;
    private _clientId;
    private _id;
    private _sessionId;
    private _info;
    private _connectionStatus;
    private _readyResolve;
    private _ready;
    constructor(props: IKernelProps);
    private initReady;
    private requestJupyterKernel;
    get ready(): Promise<void>;
    get clientId(): string;
    get id(): string;
    get sessionId(): string;
    get info(): KernelMessage.IInfoReply;
    get session(): ISessionConnection;
    get kernelManager(): KernelManager;
    get kerneSpeclManager(): KernelSpecManager;
    get sessionManager(): SessionManager;
    get path(): string;
    get connection(): JupyterKernel.IKernelConnection | null;
    toString(): string;
    shutdown(): void;
}
export default Kernel;
